import bge
import mathutils
import math

def init(controller):
  obj = controller.owner
  scene = bge.logic.getCurrentScene()

  colors = [ [200, 200, 0], [200, 0, 200], [100, 240, 100], [0, 200, 200], [240, 100, 100], [100, 100, 240] ]

  spacing = scene.objects["Map"]["spacing"]
  c_index_x = abs(obj.worldPosition.x) / spacing
  c_index_y = abs(obj.worldPosition.y) / spacing
  color = colors[math.floor(c_index_x + c_index_y) % 6]

  obj.color = mathutils.Vector(color + [255]) / 255

def update(controller):
  obj = controller.owner
  m = bge.logic.getCurrentScene().objects["Map"]

  position = obj.worldPosition

  if "map_dim" in m:
    if ((position.x > m["map_edge"].x + m["map_dim"].x - m["spacing"]) or
        (position.x < m["map_edge"].x) or
        (position.y > m["map_edge"].y + m["map_dim"].y - m["spacing"]) or
        (position.y < m["map_edge"].y)):
      obj.endObject()

def collision(controller):
  obj = controller.owner
  m = bge.logic.getCurrentScene().objects["Map"]

  # Leaving these as floats works fine too
  x = int(obj.worldPosition.x)
  y = int(obj.worldPosition.y)

  if (x not in m["eaten"]):
    m["eaten"][x] = {}
  m["eaten"][x][y] = 1

  obj.endObject()
